; 
; MemInfoMicro v.25
; Simple useful funny fancy application, source code tweak.
;  Bagayev Alex aka Antariy, Tashkent, 2008-2012


.386
.model flat,stdcall
.radix 10
option casemap:none
; 
; We need direct references to IAT, this is required for simple access to
; IAT entry, as well as for suppression of "call jump_thunk" garbage.
; So, here are the API declarations (without unnecessarily making
; "beautiful names"):

extern _imp__GetModuleHandleA@4:DWORD
extern _imp__GetProcAddress@8:DWORD
extern _imp__GlobalMemoryStatus@4:DWORD
extern _imp__ExitProcess@4:DWORD

extern _imp__wsprintfA:DWORD
extern _imp__MessageBoxA@16:DWORD


.code

			dd	offset @fpuloaddword
fpuloadcalltable	dd	offset @fpuloadqword

ifndef useTrickyWay	; if specified, then code assumes offsets of the strings in the crafted PE DOS-stub

szGBSEx_	db	"GlobalMemoryStatusEx",0
szGBSEx EQU <offset szGBSEx_>
szk32dll_	db	"kernel32.dll",0
szk32dll EQU <offset szk32dll_>
szUnits_	db	"K",0,"M",0,"G",0,"T",0,"P",0,"E",0
szUnits EQU <offset szUnits_>

szFmtStr_	db	"RAM:",10
		db		9,"Size:",9,"%d.%.3d",9,"%sB",9,10
		db		9,"Free:",9,"%d.%.3d",9,"%sB",9,10
		db	"Swap:",10
		db		9,"Size:",9,"%d.%.3d",9,"%sB",9,10
		db		9,"Free:",9,"%d.%.3d",9,"%sB",9,10,0
szFmtStr EQU <offset szFmtStr_>

else

IMGBASE EQU <400000h>

szGBSEx EQU <IMGBASE+0Fh>
szk32dll EQU <IMGBASE+2>
szUnits EQU <IMGBASE+24h>
szFmtStr EQU <IMGBASE+40h>

endif

szCaption_	db	" Antariy @ MASM32",0
szCaption EQU <offset szCaption_>

start proc

	add esp,-1024	; prepare common working buffer
ifdef useSmallerAlgo
	push 40h	; use sizeof MEMORYSTATUSEX - GlobalMemoryStatus is tolerant in Win9x
else
	push 20h	; sizeof MEMORYSTATUS (1.1) (numbers in parentheses are text references)
endif
	mov ebp,esp

					
	; try to get address of GlobalMemoryStatusEx function
	; if it exists, then the OS supports it, and is Win2k at least

	push szGBSEx ; (2.1)
	
	push szk32dll	; strange method of getting k32 base :))
	call _imp__GetModuleHandleA@4
	
	push 4	; this is the structure walking decrement counter,
	pop edi	; used below, in the main loop. Value is the size of
		; the structure entry - 4 for MEMORYSTATUS, 8 for
		; MEMORYSTATUSEX (3.1)
		
	push eax	; (2.2)
	call _imp__GetProcAddress@8
	
	push 10h	; index-4 for further usage in the main loop (4.1)
	
	mov ebx,_imp__GlobalMemoryStatus@4 ; get ptr to function (5.1)

	test eax,eax
	jz @noEx	; jump if there is no extended function
ifndef useSmallerAlgo
	shl dword ptr [ebp],1	; MEMORYSTATUSEX struct has size 40h (1.2)
endif
	add dword ptr [esp],0Ch	; for extended structure index has a larger value (4.2)
	
	add edi,edi		; for extended structure the walking decrement counter has 
				; a larger value (3.2)
				
	xchg eax,ebx	; replace ptr to function with address of extended function (5.2)
	
	@noEx:
	
	push ebp	; use common buffer as MEMORYSTATUS(EX) structure (1.3)
	call ebx	; call to standard or extended memory status function (5.3)
	
	pop ecx		; get the index for further usage (4.2)
	
	
	push 077F03E8h	; 077Fh is the new FPU control word (round down, 64 bit mantissa) (6.1)
			; 03E8h is the 1000T (constant used further) (7.1)

ifdef useSmallerAlgo
	db 0dbh,0e3h	; finit opcode, does not produce fwait
else		
	finit
endif
	fldcw word ptr [ebp-2]	; (6.2) ([ebp-2] = [esp+2])
	fild word ptr [esp]	; (7.2)
	add dword ptr [esp],24	; make constant 1024 (8.1)
	fild word ptr [esp]	; and load it (8.2)
			
	@mainloop:
		call dword ptr [fpuloadcalltable-8+edi]	; unified loop, FPU loading RT dependant
		mov edx,szUnits-2	; address of the units chars-strings array
		@divloop:	
			fdiv st(0),st(1)	; continue dividing returned structure member by 1024
			fcom st(1)		; until it is less than 1024, also incrementing pointer
			inc edx			; to units chars-strings to the next unit (8.3)
ifdef useSmallerAlgo
			db 0dfh,0e0h	; fstsw opcode, does not produce fwait
else	
			fstsw ax
endif
			inc edx
			sahf
		jae @divloop
		
		push edx	; push the address of the unit char-string
		
		; separate the integer and fractional parts and convert fractional part to integer dword
		fld st(0)	
		frndint
		push edx
		fsubr st(0),st(1)	; st(0) - fractional part
		fmul st(0),st(3)	; st(0) - integer "fractional" decimal (7.3)
		fistp dword ptr [esp]	; put "fractional" part
		push edx
		fistp dword ptr [esp]	; put integer part
		
		sub ecx,edi	; decrement index by structure walking step size (4.3, 3.3)
	jnle @mainloop	; if ecx is bigger than 0 then walk through next entry (lower address)
	
ifdef useSmallerAlgo
	db 0dbh,0e3h	; finit opcode, does not produce fwait
else	
	finit
endif
	
	push szFmtStr
	push ebp	; use common buffer as output for formatted string (1.4)
	call _imp__wsprintfA
	
	push 1040h	; MB_ICONINFORMATION or MB_SYSTEMMODAL
	push szCaption
	push ebp	; (1.5)
	push 0
	push _imp__ExitProcess@4
	jmp _imp__MessageBoxA@16
	
	; NO stack cleanup etc required


	@fpuloaddword::
	fild dword ptr [ecx+ebp+4]	; load next structure entry into FPU
	retn				; with decreasing index step (4.4)
	@fpuloadqword::
	fild qword ptr [ecx+ebp+4]	; (4.5)
	retn
	
start endp

end start
